PrimitiveIterator.OfInt (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.util, interface: PrimitiveIterator, interface: OfInt
Keywords: java.util.PrimitiveIterator.OfInt interface

# Interface PrimitiveIterator.OfInt

All Superinterfaces:
  `Iterator<Integer>, PrimitiveIterator<Integer, IntConsumer>`

Enclosing interface:
  `PrimitiveIterator<T,T_CONS>`

public static interface PrimitiveIterator.OfInt extends PrimitiveIterator<Integer, IntConsumer>
An Iterator specialized for `int` values.

Since:
  1.8

- ## Nested Class Summary

  ### Nested classes/interfaces declared in interface PrimitiveIterator

  `PrimitiveIterator.OfDouble, PrimitiveIterator.OfInt, PrimitiveIterator.OfLong`
  Modifier and Type
  Interface
  Description
  `static interface`
  `PrimitiveIterator.OfDouble`
  An Iterator specialized for `double` values.
  `static interface`
  `PrimitiveIterator.OfInt`
  An Iterator specialized for `int` values.
  `static interface`
  `PrimitiveIterator.OfLong`
  An Iterator specialized for `long` values.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `default void`
  `forEachRemaining(Consumer<? super Integer> action)`
  Performs the given action for each remaining element until all elements have been processed or the action throws an exception.
  `default void`
  `forEachRemaining(IntConsumer action)`
  Performs the given action for each remaining element until all elements have been processed or the action throws an exception.
  `default Integer`
  `next()`
  Returns the next element in the iteration.
  `int`
  `nextInt()`
  Returns the next `int` element in the iteration.

  ### Methods declared in interface Iterator

  `hasNext, remove`
  Modifier and Type
  Method
  Description
  `boolean`
  `hasNext()`
  Returns `true` if the iteration has more elements.
  `default void`
  `remove()`
  Removes from the underlying collection the last element returned by this iterator (optional operation).

- ## Method Details

  - ### nextInt

    int nextInt()
    Returns the next `int` element in the iteration.
    Returns:
      the next `int` element in the iteration
    Throws:
      `NoSuchElementException` - if the iteration has no more elements

  - ### forEachRemaining

    default void forEachRemaining(IntConsumer action)
    Performs the given action for each remaining element until all elements have been processed or the action throws an exception. Actions are performed in the order of iteration, if that order is specified. Exceptions thrown by the action are relayed to the caller.

    The behavior of an iterator is unspecified if the action modifies the source of elements in any way (even by calling the `remove` method or other mutator methods of `Iterator` subtypes), unless an overriding class has specified a concurrent modification policy.

    Subsequent behavior of an iterator is unspecified if the action throws an exception.

    Specified by:
      `forEachRemaining` in interface `PrimitiveIterator<Integer, IntConsumer>`
    Implementation Requirements:

      The default implementation behaves as if:

              while (hasNext())
                  action.accept(nextInt());

    Parameters:
      `action` - The action to be performed for each element

  - ### next

    default Integer next()
    Returns the next element in the iteration.
    Specified by:
      `next` in interface `Iterator<Integer>`
    Implementation Requirements:
      The default implementation boxes the result of calling `nextInt()`, and returns that boxed result.
    Returns:
      the next element in the iteration

  - ### forEachRemaining

    default void forEachRemaining(Consumer<? super Integer> action)
    Performs the given action for each remaining element until all elements have been processed or the action throws an exception. Actions are performed in the order of iteration, if that order is specified. Exceptions thrown by the action are relayed to the caller.

    The behavior of an iterator is unspecified if the action modifies the collection in any way (even by calling the `remove` method or other mutator methods of `Iterator` subtypes), unless an overriding class has specified a concurrent modification policy.

    Subsequent behavior of an iterator is unspecified if the action throws an exception.

    Specified by:
      `forEachRemaining` in interface `Iterator<Integer>`
    Implementation Requirements:
      If the action is an instance of `IntConsumer` then it is cast to `IntConsumer` and passed to `forEachRemaining(IntConsumer)`; otherwise the action is adapted to an instance of `IntConsumer`, by boxing the argument of `IntConsumer`, and then passed to `forEachRemaining(IntConsumer)`.
    Parameters:
      `action` - The action to be performed for each element